<template>
	<div>
		<!-- <img :src="image" class="job-bg-image"> -->
		<div class="container job-search-container">
            <div class="row justify-content-center job-search-box d-none d-sm-flex d-md-flex">
            	<div class="input-group col-md-5 col-lg-4">
            		<el-autocomplete
            		    class="inline-input"
            		    v-model="jobTitle"
            		    :fetch-suggestions="titleSearch"
            		    placeholder="Job title Or Company Name"
            		    value-key="title"
            		    :trigger-on-focus="false">
	            		    <el-button 
				        		slot="append" 
				        		@click="searchByTitle" 
				        		v-loading.fullscreen.lock="fullscreenLoading"
				        		class="jobPageBtn">
								<i class="fas fa-1x fa-search text-white" style="font-size: 1.5em"></i>
							</el-button>
            		</el-autocomplete>
	            </div>
	            <div class="input-group col-md-5 col-lg-4">
	            	<el-autocomplete
            		    class="inline-input"
            		    v-model="location"
            		    :fetch-suggestions="locationSearch"
            		    placeholder="Location"
            		    value-key="location"
            		    :trigger-on-focus="false">
	            		    <i class="el-icon-location el-input__icon" slot="suffix"></i>
			            	<el-button slot="append" @click="searchByLocation" class="jobPageBtn">
			            		<i class="fas fa-1x fa-search text-white" style="font-size: 1.5em"></i>
			            	</el-button>
            		</el-autocomplete>
	            </div>
            	<div class="input-group col-md-2 col-lg-2">
            		<el-button 
		        		@click="getJobLists" 
		        		class="jobPageBtn"
		        		v-loading.fullscreen.lock="fullscreenLoading">
						All Job
					</el-button>
            	</div>
            </div>
            <div class="row justify-content-center d-block d-sm-none">
				<h1 class="text-white text-center font-weight-bold">
					<span style="color: #42b883">JOB</span> PAGE
				</h1 class="text-white">
			</div>
        </div>
        <div class="jobpage">
			<div class="container my-5">
				<div class="row justify-content-center">
					<div v-for="jobList in jobLists.data"
						class="col-md-10 col-lg-6 mb-5"
						v-loading="loading"
						:key="jobList.id">
						<div class="card-body job-list-card">
						    <h3 class="card-title">
						    	<i class="fas fa-briefcase mr-3"></i>{{ jobList.title }}
						    </h3>
						    <h6 class="my-3">
						    	<span class="mr-4"><i class="job-page-icon fa fa-bookmark"></i>  {{ jobList.position_type }}</span>
						    	<span class="mr-4"><i class="job-page-icon fa fa-map-marker"></i>  {{ jobList.location }}</span>
						    	<span class="mr-4"><i class="job-page-icon fa fa-money-bill-alt"></i>  {{ jobList.salary }}</span>
						    </h6>
						    <h5 class="card-desc"><u>Description</u></h5>
						    <p class="card-text my-3">{{ jobList.description }}</p>
						    <apply-button :user="user" :id="jobList.id" :is_applied="jobList.is_applied"></apply-button>
						</div>
					</div>
					<div v-if="noResult" class="mt-4">
						<h3><span style="color: #42b883">SORRY!</span> No job to show :(</h3>
					</div>
				</div>
				<pagination :data="jobLists" @pagination-change-page="getJobLists"></pagination>
			</div>
        </div>
	</div>
</template>

<style>
	.el-autocomplete {
		width: 100%;
	}
	.el-input__inner {
		height: 40px;
		border-radius: none;
	}
	.el-input.is-active .el-input__inner, .el-input__inner:focus {
		border-color: #42b883;
	}
	.jobPageBtn {
		background-color: #42b883!important;
		vertical-align: middle;
    	height: 40px;
		outline: none;
		z-index: 1;
		position: relative;
		color: #fff;
		font-weight: bold;
	}
	.jobPageBtn:focus, .jobPageBtn:hover {
		outline: none;
		background-color: #42b883;
		color: #fff;
	}
	.jobPageBtn:hover::before {
	    background-color: rgba(255,255,255,.2);
	    opacity: 1;
	    transform: scale(1,1); 
	}
	.jobPageBtn::before {
    	content: '';
	    position: absolute;
	    top: 0;
	    left: 0;
	    width: 100%;
	    height: 100%;
	    z-index: 1;
	    opacity: 0;
	    transform: scale(0,0);
	    z-index: -1;
	    transition: all .5s ease-out 0s;
	}
</style>

<script>
	import jobImage from "../../../images/job-bg.jpeg"
	import applyButton from "./apply_button.vue"

	export default {
		props: ['user'],
		data() {
			return {
				image: jobImage,
				jobLists: {},
				jobTitle: '',
				location: '',
				applyStatus: '',
				noResult: false,
				loading: false,
				fullscreenLoading: false
			}
		},
		created() {
			this.applyStatus = this.is_applied
		},
		components : {
			'apply-button': applyButton,
		},
		methods: {
			titleSearch(queryString, cb) {
		        var jobLists = this.jobLists.data;
		        var results = queryString ? jobLists.filter(this.titleFilter(queryString)) : jobLists;
		        // call callback function to return suggestions
		        cb(results);
		      },
		    titleFilter(queryString) {
		        return (jobList) => {
		          return (jobList.title.toLowerCase().indexOf(queryString.toLowerCase()) === 0);
		        };
		    },
		    locationSearch(queryString, cb) {
		        var jobLists = this.jobLists.data;
		        var results = queryString ? jobLists.filter(this.locationFilter(queryString)) : jobLists;
		        // call callback function to return suggestions
		        cb(results);
		      },
		    locationFilter(queryString) {
		        return (jobList) => {
		          return (jobList.location.toLowerCase().indexOf(queryString.toLowerCase()) === 0);
		        };
		    },
			searchByTitle() {
				this.fullscreenLoading = true;
				setTimeout(() => {
		          this.fullscreenLoading = false;
		        }, 500);
				axios.get('job/searchByTitle/' + this.jobTitle)
				.then(response => {
					
					this.jobLists = response;
					if (response.data.length == 0) {
						this.noResult =  true
					}
				})
			},
			searchByLocation() {
				this.fullscreenLoading = true;
				setTimeout(() => {
		          this.fullscreenLoading = false;
		        }, 500);
				axios.get('job/searchByLocation/' + this.location)
				.then(response => {
					
					this.jobLists = response;
					if (response.data.length == 0) {
						this.noResult =  true
					}
				})
			},
			getJobLists(page) {
				this.loading = true;
				if (typeof page === 'undefined') {
					page = 1;
				}

				axios.get('/job?page=' + page)
				.then(response => {
					this.jobLists = response.data;
					if (response.data.data.length == 0) {
						this.noResult =  true
					}
					this.noResult = false;
				})
				.finally(() => this.loading = false)
			},
			apply(id) {
				axios.post('/applier', {
	                user_id: this.$auth.user().id,
	                job_id: id,
	            })
	            .then(response => {
	            	this.applyStatus = response.data;
	                this.$message({
	                	type: 'success', 	
	                	message: 'Thank for your apply. We will contact you soon.',
	                });
	            })
			},
		},
		mounted() {
			this.getJobLists();
		}
	}
</script>